// Code generated by gobind. DO NOT EDIT.

// Java class com.proton.gopenpgp.crypto.Crypto is a proxy for talking to a Go program.
//
//   autogenerated by gobind -lang=java -javapkg=com.proton.gopenpgp github.com/ProtonMail/gopenpgp/v2/crypto
package com.proton.gopenpgp.crypto;

import go.Seq;

public abstract class Crypto {
	static {
		Seq.touch(); // for loading the native library
		com.proton.gopenpgp.armor.Armor.touch();
		com.proton.gopenpgp.constants.Constants.touch();
		_init();
	}
	
	private Crypto() {} // uninstantiable
	
	// touch is called from other bound packages to initialize this package
	public static void touch() {}
	
	private static native void _init();
	
	private static final class proxyMIMECallbacks implements Seq.Proxy, MIMECallbacks {
		private final int refnum;
		
		@Override public final int incRefnum() {
		      Seq.incGoRef(refnum, this);
		      return refnum;
		}
		
		proxyMIMECallbacks(int refnum) { this.refnum = refnum; Seq.trackGoRef(refnum, this); }
		
		public native void onAttachment(String headers, byte[] data);
		public native void onBody(String body, String mimetype);
		public native void onEncryptedHeaders(String headers);
		public native void onError(java.lang.Exception err);
		public native void onVerified(long verified);
	}
	
	
	/**
	 * DecryptMessageWithPassword decrypts password protected pgp binary messages.
	* encrypted: The encrypted data as PGPMessage.
	* password: A password that will be derived into an encryption key.
	* output: The decrypted data as PlainMessage.
	 */
	public static native PlainMessage decryptMessageWithPassword(PGPMessage message, byte[] password) throws Exception;
	/**
	 * DecryptSessionKeyWithPassword decrypts the binary symmetrically encrypted
	session key packet and returns the session key.
	 */
	public static native SessionKey decryptSessionKeyWithPassword(byte[] keyPacket, byte[] password) throws Exception;
	/**
	 * EncryptMessageWithPassword encrypts a PlainMessage to PGPMessage with a
	SymmetricKey.
	* message : The plain data as a PlainMessage.
	* password: A password that will be derived into an encryption key.
	* output  : The encrypted data as PGPMessage.
	 */
	public static native PGPMessage encryptMessageWithPassword(PlainMessage message, byte[] password) throws Exception;
	/**
	 * EncryptSessionKeyWithPassword encrypts the session key with the password and
	returns a binary symmetrically encrypted session key packet.
	 */
	public static native byte[] encryptSessionKeyWithPassword(SessionKey sk, byte[] password) throws Exception;
	// skipped function FilterExpiredKeys with unsupported parameter or return types
	
	/**
	 * GenerateKey generates a key of the given keyType (&#34;rsa&#34; or &#34;x25519&#34;).
	If keyType is &#34;rsa&#34;, bits is the RSA bitsize of the key.
	If keyType is &#34;x25519&#34; bits is unused.
	 */
	public static native Key generateKey(String name, String email, String keyType, long bits) throws Exception;
	/**
	 * GenerateRSAKeyWithPrimes generates a RSA key using the given primes.
	 */
	public static native Key generateRSAKeyWithPrimes(String name, String email, long bits, byte[] primeone, byte[] primetwo, byte[] primethree, byte[] primefour) throws Exception;
	/**
	 * GenerateSessionKey generates a random key for the default cipher.
	 */
	public static native SessionKey generateSessionKey() throws Exception;
	/**
	 * GenerateSessionKeyAlgo generates a random key of the correct length for the
	specified algorithm.
	 */
	public static native SessionKey generateSessionKeyAlgo(String algo) throws Exception;
	// skipped function GetTime with unsupported parameter or return types
	
	/**
	 * GetUnixTime gets latest cached time.
	 */
	public static native long getUnixTime();
	/**
	 * IsPGPMessage checks if data if has armored PGP message format.
	 */
	public static native boolean isPGPMessage(String data);
	/**
	 * NewClearTextMessage generates a new ClearTextMessage from data and
	signature.
	 */
	public static native ClearTextMessage newClearTextMessage(byte[] data, byte[] signature);
	/**
	 * NewClearTextMessageFromArmored returns the message body and unarmored
	signature from a clearsigned message.
	 */
	public static native ClearTextMessage newClearTextMessageFromArmored(String signedMessage) throws Exception;
	/**
	 * NewKey creates a new key from the first key in the unarmored binary data.
	 */
	public static native Key newKey(byte[] binKeys) throws Exception;
	/**
	 * NewKeyFromArmored creates a new key from the first key in an armored string.
	 */
	public static native Key newKeyFromArmored(String armored) throws Exception;
	// skipped function NewKeyFromArmoredReader with unsupported parameter or return types
	
	// skipped function NewKeyFromReader with unsupported parameter or return types
	
	/**
	 * NewKeyRing creates a new KeyRing, empty if key is nil.
	 */
	public static native KeyRing newKeyRing(Key key) throws Exception;
	/**
	 * NewPGPMessage generates a new PGPMessage from the unarmored binary data.
	 */
	public static native PGPMessage newPGPMessage(byte[] data);
	/**
	 * NewPGPMessageFromArmored generates a new PGPMessage from an armored string ready for decryption.
	 */
	public static native PGPMessage newPGPMessageFromArmored(String armored) throws Exception;
	/**
	 * NewPGPSignature generates a new PGPSignature from the unarmored binary data.
	 */
	public static native PGPSignature newPGPSignature(byte[] data);
	/**
	 * NewPGPSignatureFromArmored generates a new PGPSignature from the armored
	string ready for verification.
	 */
	public static native PGPSignature newPGPSignatureFromArmored(String armored) throws Exception;
	/**
	 * NewPGPSplitMessage generates a new PGPSplitMessage from the binary unarmored keypacket,
	datapacket, and encryption algorithm.
	 */
	public static native PGPSplitMessage newPGPSplitMessage(byte[] keyPacket, byte[] dataPacket);
	/**
	 * NewPGPSplitMessageFromArmored generates a new PGPSplitMessage by splitting an armored message into its
	session key packet and symmetrically encrypted data packet.
	 */
	public static native PGPSplitMessage newPGPSplitMessageFromArmored(String encrypted) throws Exception;
	/**
	 * NewPlainMessage generates a new binary PlainMessage ready for encryption,
	signature, or verification from the unencrypted binary data.
	 */
	public static native PlainMessage newPlainMessage(byte[] data);
	// skipped function NewPlainMessageFromFile with unsupported parameter or return types
	
	/**
	 * NewPlainMessageFromString generates a new text PlainMessage,
	ready for encryption, signature, or verification from an unencrypted string.
	 */
	public static native PlainMessage newPlainMessageFromString(String text);
	public static native SessionKey newSessionKeyFromToken(byte[] token, String algo);
	/**
	 * RandomToken generates a random token with the specified key size.
	 */
	public static native byte[] randomToken(long size) throws Exception;
	/**
	 * SetKeyGenerationOffset updates the offset when generating keys.
	 */
	public static native void setKeyGenerationOffset(long offset);
	/**
	 * UpdateTime updates cached time.
	 */
	public static native void updateTime(long newTime);
}
